# -*- coding: utf-8 -*-
import re, json, time
import hashlib
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import quote
except ImportError:
    from urllib.parse import quote


def get(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return {'code': 'iqiyi 200', 'error': str(e)}
    sourceid = re.search(r'sourceId:\s*"{0,1}(\d+)"{0,1}', content)
    if not sourceid or sourceid.group(1) == '0':
        sourceid = re.search(r'albumId:\s*"{0,1}(\d*)"{0,1}', content)
        if not sourceid:
            sourceid = re.search(r'data-player-albumid="(\d*)"', content)
            if not sourceid:
                return {'code': 'iqiyi 201'}
    sourceid = sourceid.group(1)
    url = 'http://pcw-api.iqiyi.com/albums/album/avlistinfo?aid=%s&size=1000&page=1' % sourceid
    try:
        content2 = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return {'code': 'iqiyi 202', 'error': str(e)}
    try:
        data = json.loads(content2)
    except Exception as e:
        return {'code': 'iqiyi 203', 'error': str(e)}
    ret = []
    for tv in data['data']['epsodelist']:
        ret.append({'title': tv['name'], 'url': tv['playUrl']})
    if ret:
        return ret
    cid = re.search(r'cid:\s*(\d+)', content)
    if not cid:
        cid = '6'
    else:
        cid = cid.group(1)
    url = 'http://cache.video.iqiyi.com/jp/sdvlst/%s/%s/' % (cid, sourceid)
    try:
        content2 = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return {'code': 'iqiyi 204', 'error': str(e)}
    content2 = re.search(r'var tvInfoJs=(.*)', content2)
    if not content2:
        return {'code': 'iqiyi 205'}
    content2 = content2.group(1)
    try:
        data = json.loads(content2)
    except Exception as e:
        return {'code': 'iqiyi 206', 'error': str(e)}
    for tv in data['data']:
        ret.append({'title': tv['shortTitle'], 'url': tv['vUrl']})
    return ret


def play(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return {'code': 'iqiyi 300', 'error': str(e)}
    tvid = re.search(r'"tvId":(.*?),', content)
    if not tvid:
        return {'code': 'iqiyi 301'}
    tvid = tvid.group(1)
    videoid = re.search(r'"vid":"(.*?)"', content)
    if not videoid:
        return {'code': 'iqiyi 302'}
    videoid = videoid.group(1)
    t = str(int(time.time() * 1000))
    src = '76f90cbd92f94a2e925d83e8ccd22cb7'
    key = 'd5fb4bd9d50c4be6948c97edd7254b0e'
    sc = hashlib.new('md5', (t + key + videoid).encode('utf-8')).hexdigest()
    url = 'http://cache.m.iqiyi.com/tmts/' + tvid + '/' + videoid + '/?t=' + t + '&sc=' + sc + '&src=' + src
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return {'code': 'iqiyi 303', 'error': str(e)}
    try:
        data = json.loads(content)
    except Exception as e:
        return {'code': 'iqiyi 304', 'error': str(e)}
    urls = {}
    try:
        for stream in data['data']['vidl']:
            urls[str(stream['vd'])] = stream['m3utx']
    except Exception as e:
        return {'code': 'iqiyi 305', 'error': str(e)}
    return {'title': '', 'url': urls}
